{-# LANGUAGE FlexibleContexts #-}
module Database  where

import Control.Monad.IO.Class
import Control.Monad.State.Strict
import Database.HDBC.Sqlite3 
import Database.HDBC
import Data.List.Split
import System.Environment.FindBin
import Paths_Villefort
  
type Query = String
type Path  = String
type Subject = String


--getSubjects :: IO (Maybe [Subject])
getSubjects = (\x-> (!! 0) <$> x) <$> makeQuery "select Subject from todo where state = 0 group by Subject"

--path =fmap (\x -> (x !! 0) ++ "Villefort.app/Contents/Resources/") $  (Data.List.Split.splitOn "Villefort.app") <$> getProgPath
--path :: IO Path
path =fmap (\x -> (x !! 0) ++ "Villefort/") $  (Data.List.Split.splitOn "Villefort/") <$> getProgPath
--path = getDataDir

path' = getDataDir

getDb :: IO Connection  
getDb =  (++ "/data/todo.db") <$> path' >>= \path -> putStrLn path >> connectSqlite3 path

--convRow :: [[SqlValue]] -> [[String]]
convRow dat = Prelude.map (\x -> Prelude.map (\y -> fromSql y :: String ) x) dat


--makeQuery :: Query -> IO [[String]]
makeQuery query = do
  conn <- getDb
  taskRaw <- quickQuery' conn query []
  disconnect conn
  return (convRow taskRaw)
  {-
makeQuery query =  getDb >>=  \conn  ->  quickQuery' conn query [] >>=
  \taskRaw -> disconnect conn >> return ( convRow taskRaw)

-}
  

execQuery :: Query -> [Int] -> IO ()
execQuery query params =  getDb >>= \conn ->  prepare conn query >>=
  \stmt ->  execute stmt ( map toSql params) >>  commit conn >> disconnect conn
